package startapp.free.com.startapp;

import android.content.Context;
import android.util.Log;
import android.view.View;
import android.widget.FrameLayout;

import io.flutter.plugin.common.BinaryMessenger;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.platform.PlatformView;

import com.startapp.android.publish.ads.banner.Banner;
import com.startapp.android.publish.ads.banner.BannerListener;

import org.json.JSONException;
import org.json.JSONObject;

import java.lang.reflect.Field;
import java.util.HashMap;
import java.util.Map;

public class StartappBanner implements PlatformView {
    private final FrameLayout bannerContainer;
    private Object data;
    private MethodChannel channel;

    StartappBanner(Context context, BinaryMessenger messenger, int id, Object o) {
        this.bannerContainer = new FrameLayout(context);
        this.data = o;
        this.channel = new MethodChannel(messenger, startapp.free.com.startapp.StartappPlugin.pluginKey + "_" + id);
        try {
            JSONObject size = new org.json.JSONObject(data.toString());
            int width = Integer.parseInt(size.get("width").toString());
            int height = Integer.parseInt(size.get("height").toString());
            Banner banner = new Banner(StartappPlugin.getContext(), new BannerListener() {
                @Override
                public void onReceiveAd(View banner) {
                    System.out.println("Ad: onReceiveAd");
                    channel.invokeMethod("onReceiveAd", null);
                    updateContent(banner);
                }

                @Override
                public void onFailedToReceiveAd(View banner) {
                    System.out.println("Ad: onFailedToReceiveAd");
                    channel.invokeMethod("onFailedToReceiveAd", null);
                    updateContent(banner);
                }

                @Override
                public void onClick(View banner) {
                    System.out.println("Ad: onClick");
                    channel.invokeMethod("onClick", null);
                    updateContent(banner);
                }

                @Override
                public void onImpression(View view) {
                    channel.invokeMethod("onImpression", null);
                    System.out.println("Ad: onImpression");
                }
            });
            banner.loadAd(width, height);
        } catch (Exception e) {

        }
    }

    private void updateContent(View banner) {
        bannerContainer.removeAllViews();
        bannerContainer.addView(banner);
    }


    @Override
    public View getView() {
        return bannerContainer;
    }

    @Override
    public void dispose() {
        bannerContainer.removeAllViews();
    }
}
