package startapp.free.com.startapp;

import android.app.Activity;
import android.util.Log;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.PluginRegistry.Registrar;

import com.startapp.android.publish.adsCommon.Ad;
import com.startapp.android.publish.adsCommon.StartAppAd;
import com.startapp.android.publish.adsCommon.StartAppSDK;

import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;

/** StartappPlugin */
public class StartappPlugin implements MethodChannel.MethodCallHandler {
  public static final String pluginKey = "startapp/banner";
  public static Activity mainActivity;

  public StartappPlugin(Activity activity) {
    this.mainActivity = activity;
  }

  public static void registerWith(Registrar registrar) {
    MethodChannel channel = new MethodChannel(registrar.messenger(), "startapp");
    channel.setMethodCallHandler(new StartappPlugin(registrar.activity()));

    registrar.platformViewRegistry().registerViewFactory(pluginKey, new StartappBannerFactory(registrar.messenger()));
  }

  @Override
  public void onMethodCall(MethodCall methodCall, MethodChannel.Result result) {
    if (mainActivity == null) {
      result.error("no_activity", "this plugin requires a foreground activity", null);
      return;
    }
    switch (methodCall.method) {
      case "initialize":
        String appId = methodCall.argument("appId");
        StartAppSDK.init(mainActivity, appId, false);
        StartAppAd.disableSplash();
        result.success(Boolean.TRUE);
        break;
      default:
        result.notImplemented();

    }
  }

  static public Activity getContext() {
    return mainActivity;
  }
}
